#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>

#define IN 0
#define OUT 1

int * pipepair()
{
	int * pipes = calloc(2, sizeof(int));
	if(pipe(pipes) != 0)
	{
		free(pipes);
		pipes = NULL;
	}
	return pipes;
}

int main()
{
	int * pipes = pipepair();
	if(pipes == NULL)
	{
		return -1;
	}
	pid_t pid = fork();
	if(pid == 0)
	{
		// Make the pipe's input stdout (fd 1)
		dup2(pipes[OUT], 1);
		// Close the old file descriptor, since we aren't using it anymore.
		close(pipes[OUT]);
		char *arg[2] = {"/bin/ls", 0};
		execv(arg[0], arg);
	}
	else
	{
		unsigned int i=0;
		char buffer[1024];
		// Turn the file descriptor into a FILE
		FILE * ls_pipe = fdopen(pipes[IN], "r");
		// Close the out end of the pipe
		close(pipes[OUT]);
		while(fgets(buffer, 1024, ls_pipe))
		{
			printf("%d: %s",i++, buffer);
		}
	}
	return 0;
}
