#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>

#define IN 0
#define OUT 1

int * pipepair()
{
	int * pipes = calloc(2, sizeof(int));
	if(pipe(pipes) != 0)
	{
		free(pipes);
		pipes = NULL;
	}
	return pipes;
}

int main(void)
{
	int * pipes = pipepair();
	if(pipes == NULL)
	{
		return -1;
	}
	pid_t pid = fork();
	if(pid == 0)
	{
		char buffer[1024];
		read(pipes[IN], buffer, 1024);
		printf("Child process received: %s\n",buffer);
	}
	else
	{
		char * message = "A simple message";
		printf("Parent process sending %s\n", message);
		write(pipes[OUT], message, strlen(message)+1);
	}
	return 0;
}
